> For the complete documentation index, see [llms.txt](https://docs.stacks.co/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.stacks.co/reference/stacks.js/stacks-transactions/builders/makecontractdeploy.md).

# makeContractDeploy

Constructs and signs a smart contract deployment transaction. Deploys a Clarity smart contract to the Stacks blockchain.

***

### Usage

```ts
import { makeContractDeploy, ClarityVersion } from '@stacks/transactions';

const codeBody = `
(define-public (say-hello)
  (ok "hello world"))
`;

const transaction = await makeContractDeploy({
  contractName: 'hello-world',
  codeBody,
  senderKey: 'b244296d5907de9864c0b0d51f98a13c52890be0404e83f273144004b81874603',
  network: 'testnet',
  fee: 10000n,
  nonce: 0n,
  clarityVersion: ClarityVersion.Clarity3,
});

const serializedTx = transaction.serialize();
```

#### Notes

* The `codeBody` should be a valid Clarity source code string.
* If `clarityVersion` is omitted, the latest available version is used.
* If `fee` is omitted, the fee is estimated automatically.
* If `nonce` is omitted, the nonce is fetched automatically.

[**Reference Link**](https://github.com/stx-labs/stacks.js/tree/main/packages/transactions/src/builders.ts#L283)

***

### Signature

```ts
function makeContractDeploy(
  txOptions: SignedContractDeployOptions | SignedMultiSigContractDeployOptions
): Promise<StacksTransactionWire>
```

***

### Returns

`Promise<StacksTransactionWire>`

A promise that resolves to a signed `StacksTransactionWire` object, ready to be broadcast.

***

### Parameters

#### txOptions (required)

* **Type**: `SignedContractDeployOptions | SignedMultiSigContractDeployOptions`

```ts
interface SignedContractDeployOptions extends BaseContractDeployOptions {
  senderKey: PrivateKey;
}

type SignedMultiSigContractDeployOptions = BaseContractDeployOptions & SignedMultiSigOptions;

type BaseContractDeployOptions = {
  /** The name for the deployed contract */
  contractName: string;
  /** The Clarity source code for the contract */
  codeBody: string;
  /** The Clarity version to use (defaults to latest) */
  clarityVersion?: ClarityVersion;
  /** Post conditions for the transaction */
  postConditions?: PostCondition[];
  /** Post condition mode (Allow or Deny) */
  postConditionMode?: PostConditionMode;
  /** Whether the transaction is sponsored */
  sponsored?: boolean;
  /** Transaction fee in microSTX */
  fee?: IntegerType;
  /** Transaction nonce */
  nonce?: IntegerType;
} & NetworkClientParam;
```

For single-sig, provide `senderKey`. For multi-sig, provide `publicKeys`, `numSignatures`, and `signerKeys`.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.stacks.co/reference/stacks.js/stacks-transactions/builders/makecontractdeploy.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
